# The pywwt Jupyter Widget Frontend Module

This NPM package contains the JavaScript code implementing the frontend of the
[pywwt] [Jupyter Widget]. As such, this package is mostly a pywwt implementation
detail.

[pywwt]: https://pywwt.readthedocs.io/
[Jupyter Widget]: https://ipywidgets.readthedocs.io/

To use the [WorldWide Telescope][wwt] (WWT) technology inside the
[JupyterLab] computational environment (NB: JupyterLab is distinct from
“vanilla” Jupyter), we recommend that you skip this widget and instead use the
[wwt-jupyterlab] extension. The dedicated extension installs the more powerful
WWT “[research app]” into your JupyterLab environment. That being said, this
package also includes a small JupyterLab extension that makes the pywwt widget
available within the JupyterLab context, if that’s what you want to use.

[wwt]: https://worldwidetelescope.org/home
[JupyterLab]: https://jupyterlab.readthedocs.io/
[wwt-jupyterlab]: https://github.com/WorldWideTelescope/wwt-jupyterlab/
[research app]: https://docs.worldwidetelescope.org/research-app/latest/

To write your own WWT-based web apps, check out [documentation for the WWT web
stack][web-docs].

[web-docs]: https://docs.worldwidetelescope.org/webgl-reference/latest/

The WorldWide Telescope project is fiscally sponsored by
[NumFOCUS](https://numfocus.org/). Consider making a [tax-deductible
donation](https://numfocus.org/donate-for-worldwide-telescope) to help support
the project. Work on WWT has been supported by the [American Astronomical
Society] (AAS), the [.NET Foundation], and other organizational partners. See
[the WWT user website][acks] for details.

[American Astronomical Society]: https://aas.org/
[.NET Foundation]: https://dotnetfoundation.org/
[acks]: https://worldwidetelescope.org/about/acknowledgments/

